#ifndef EFL_UI_DRAGGABLE_EO_HH
#define EFL_UI_DRAGGABLE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_object.eo.h"
#include "efl_ui_draggable.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_object.eo.hh"
#ifndef EFL_UI_DRAGGABLE_FWD_GUARD
#define EFL_UI_DRAGGABLE_FWD_GUARD
namespace efl { namespace ui { 
struct Draggable;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Draggable> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Draggable&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Draggable const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Draggable const&> : ::std::true_type {}; } }
#endif
#ifndef EFL_OBJECT_FWD_GUARD
#define EFL_OBJECT_FWD_GUARD
namespace efl { 
struct Object;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object const&> : ::std::true_type {}; } }
#endif

namespace eo_cxx {
namespace efl { namespace ui { 
struct Draggable {
   ::efl::eolian::return_traits<bool>::type drag_target_get() const;
   ::efl::eolian::return_traits<void>::type drag_target_set( ::efl::eolian::in_traits<bool>::type set) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_DRAGGABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Draggable *>(this))); }
   operator ::efl::ui::Draggable() const;
   operator ::efl::ui::Draggable&();
   operator ::efl::ui::Draggable const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Draggable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Draggable const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Draggable : private ::efl::eo::concrete
{
   explicit Draggable( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   Draggable(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   explicit Draggable() = default;
   Draggable(Draggable const&) = default;
   Draggable(Draggable&&) = default;
   Draggable& operator=(Draggable const&) = default;
   Draggable& operator=(Draggable&&) = default;
   template <typename Derived>
   Draggable(Derived&& derived
      , typename std::enable_if<
         ::efl::eo::is_eolian_object<Derived>::value
          && std::is_base_of< Draggable, Derived>::value>::type* = 0)
         : ::efl::eo::concrete(derived._eo_ptr()) {}

   ::efl::eolian::return_traits<bool>::type drag_target_get() const;
   ::efl::eolian::return_traits<void>::type drag_target_set( ::efl::eolian::in_traits<bool>::type set) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_DRAGGABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Draggable *>(this))); }
   static struct drag_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG; }
      typedef  ::efl::Object parameter_type;
   } const drag_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_event, *this, std::bind(function));
   }
#endif
   static struct drag_start_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG_START; }
      typedef void parameter_type;
   } const drag_start_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_start_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_start_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_start_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_start_event, *this, std::bind(function));
   }
#endif
   static struct drag_stop_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG_STOP; }
      typedef  ::efl::Object parameter_type;
   } const drag_stop_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_stop_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_stop_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_stop_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_stop_event, *this, std::bind(function));
   }
#endif
   static struct drag_end_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG_END; }
      typedef void parameter_type;
   } const drag_end_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_end_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_end_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_end_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_end_event, *this, std::bind(function));
   }
#endif
   static struct drag_start_up_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG_START_UP; }
      typedef  ::efl::Object parameter_type;
   } const drag_start_up_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_start_up_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_start_up_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_start_up_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_start_up_event, *this, std::bind(function));
   }
#endif
   static struct drag_start_down_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG_START_DOWN; }
      typedef  ::efl::Object parameter_type;
   } const drag_start_down_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_start_down_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_start_down_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_start_down_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_start_down_event, *this, std::bind(function));
   }
#endif
   static struct drag_start_right_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG_START_RIGHT; }
      typedef  ::efl::Object parameter_type;
   } const drag_start_right_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_start_right_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_start_right_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_start_right_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_start_right_event, *this, std::bind(function));
   }
#endif
   static struct drag_start_left_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_DRAG_START_LEFT; }
      typedef  ::efl::Object parameter_type;
   } const drag_start_left_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_start_left_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_start_left_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   drag_start_left_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(drag_start_left_event, *this, std::bind(function));
   }
#endif
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Draggable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Draggable const > operator&() const { return {this}; }
   /// @endcond
   ::efl::eo::wref<Draggable> _get_wref() const { return ::efl::eo::wref<Draggable>(*this); }
   ::efl::eo::concrete const& _get_concrete() const { return *this; }
   ::efl::eo::concrete& _get_concrete() { return *this; }
   using ::efl::eo::concrete::_eo_ptr;
   using ::efl::eo::concrete::_release;
   using ::efl::eo::concrete::_reset;
   using ::efl::eo::concrete::_delete;
   using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
   const Draggable* operator->() const { return this; }
   Draggable* operator->() { return this; }
   operator Eo*() const { return _eo_ptr(); }
#endif 
   friend bool operator==(Draggable const& lhs, Draggable const& rhs)
   { return lhs._get_concrete() == rhs._get_concrete(); }
   friend bool operator!=(Draggable const& lhs, Draggable const& rhs)
   { return !(lhs == rhs); }
};
static_assert(sizeof(Draggable) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Draggable>::value, "");
} } 
#endif
